<?php

namespace Drupal\podcast_publisher_analytics\Entity;

use Drupal\Core\Entity\ContentEntityBase;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Field\BaseFieldDefinition;

/**
 * Defines the UserAgent entity.
 *
 * @ContentEntityType(
 *   id = "podcast_geo_area",
 *   label = @Translation("Podcast Geo Area"),
 *   base_table = "podcast_geo_area",
 *   entity_keys = {
 *     "id" = "id",
 *     "uuid" = "uuid",
 *   },
 * )
 */
class GeoArea extends ContentEntityBase {

  /**
   * {@inheritdoc}
   */
  public static function baseFieldDefinitions(EntityTypeInterface $entity_type) {
    // Standard field, used as unique if primary index.
    $fields['id'] = BaseFieldDefinition::create('integer')
      ->setLabel(t('ID'))
      ->setDescription(t('The ID of the User Agent entity.'))
      ->setReadOnly(TRUE);

    // Standard field, unique outside the scope of the current project.
    $fields['uuid'] = BaseFieldDefinition::create('uuid')
      ->setLabel(t('UUID'))
      ->setDescription(t('The UUID of the User Agent entity.'))
      ->setReadOnly(TRUE);

    $fields['name'] = BaseFieldDefinition::create('string')
      ->setLabel(t('Name'));

    $fields['parent'] = BaseFieldDefinition::create('entity_reference')
      ->setTargetEntityTypeId('podcast_geo_area')
      ->setLabel(t('Parent Area'));

    $fields['code'] = BaseFieldDefinition::create('string')
      ->setLabel(t('Code'));

    $fields['area_type'] = BaseFieldDefinition::create('string')
      ->setLabel(t('Area Type'));

    return $fields;
  }

}
