<?php

namespace Drupal\podcast_publisher_analytics\Entity;

use Drupal\Core\Entity\ContentEntityBase;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Field\BaseFieldDefinition;

/**
 * Defines the UserAgent entity.
 *
 * @ContentEntityType(
 *   id = "podcast_user_agent",
 *   label = @Translation("Podcast User Agent"),
 *   base_table = "podcast_user_agent",
 *   entity_keys = {
 *     "id" = "id",
 *     "uuid" = "uuid",
 *   },
 * )
 */
class UserAgent extends ContentEntityBase {

  /**
   * {@inheritdoc}
   */
  public static function baseFieldDefinitions(EntityTypeInterface $entity_type) {
    // Standard field, used as unique if primary index.
    $fields['id'] = BaseFieldDefinition::create('integer')
      ->setLabel(t('ID'))
      ->setDescription(t('The ID of the User Agent entity.'))
      ->setReadOnly(TRUE);

    // Standard field, unique outside the scope of the current project.
    $fields['uuid'] = BaseFieldDefinition::create('uuid')
      ->setLabel(t('UUID'))
      ->setDescription(t('The UUID of the User Agent entity.'))
      ->setReadOnly(TRUE);

    $fields['user_agent'] = BaseFieldDefinition::create('string')
      ->setLabel(t('User Agent'))
      ->setDescription(t('The user agent.'));

    $fields['bot'] = BaseFieldDefinition::create('boolean')
      ->setLabel(t('Bot'))
      ->setDescription(t('Indicator whether the user agent should be treated as a bot.'));

    $fields['client_name'] = BaseFieldDefinition::create('string')
      ->setLabel(t('Client Name'));

    $fields['os_name'] = BaseFieldDefinition::create('string')
      ->setLabel(t('OS Name'));

    return $fields;
  }

}
